package net.greenfieldtech.cloudonixsdk.cloudonixdialer.utils;

import android.text.TextUtils;
import java.util.ArrayList;
import net.greenfieldtech.cloudonixsdk.api.interfaces.IVoIPObserver;
import net.greenfieldtech.cloudonixsdk.appinterface.VoipCall;
import net.greenfieldtech.cloudonixsdk.utils.StorageAndPrefsWrapper;


/**
 * Created by alex on 04.05.16.
 */

public class SdkFacade {

  public static boolean isCodecSelected() {
    StorageAndPrefsWrapper prefs = StorageAndPrefsWrapper.getInstance();
    if (prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_OPUS, false)
        || prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_ILBC, false)
        || prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_G722, false)
        || prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_G711, false)) {
      return true;
    }
    return false;
  }

  public static String getEnabledCodecs() {
    StorageAndPrefsWrapper prefs = StorageAndPrefsWrapper.getInstance();
    String opus =
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_OPUS, false) ? "Opus" : "";
    String iLBC =
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_ILBC, false) ? "iLBC" : "";
    String g722 =
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_G722, false) ? "G722" : "";
    String g711 =
        prefs.getBoolean(StorageAndPrefsWrapper.PreferencesKeys.USE_G711, false) ? "G711" : "";

    ArrayList<String> codecArray = new ArrayList<>();
    if (!TextUtils.isEmpty(opus)) {
      codecArray.add(opus);
    }
    if (!TextUtils.isEmpty(iLBC)) {
      codecArray.add(iLBC);
    }
    if (!TextUtils.isEmpty(g722)) {
      codecArray.add(g722);
    }
    if (!TextUtils.isEmpty(g711)) {
      codecArray.add(g711);
    }
    return TextUtil.getCodecString(codecArray);
  }

  public static String findActiveCall(String currentCallId) {
    String result = null;
    VoIPClient client = VoIPClient.getInstance();
    if (client.isRegistered()) {
      VoipCall[] calls = client.getCalls();
      for (int i = 0; i < calls.length; i++) {
        if (calls[i].callState == IVoIPObserver.CallState.CALL_STATE_MEDIAACTIVE) {
          result = calls[i].key;
        }
      }
    }
    if (result == null) {
      return currentCallId;
    }
    return result;
  }

}